﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Input;

namespace BlackStar
{

    public class ButtonContentReader : ContentTypeReader<Button>
    {
        protected override Button Read(ContentReader input, Button existingInstance)
        {
            Button result = new Button();
            result.ReadContent(input);
            return result;
        }
    }

    public class Button : Component
    {
        public event ComponentEvent Click;

        protected string myStyle = "Default";

        protected internal override void ReadContent(ContentReader input)
        {
            base.ReadContent(input);
        }

        public override void Draw()
        {
            if (!myVisible) return;

            if (this.HasFocus())
            {
                // draw the focus rectangle.
                gui.theme.Button.Draw("Focused", myDrawRectangle, this.Color);
            }
            else
            {
                gui.theme.Button.Draw(myStyle, myDrawRectangle, this.Color);
            }

            myGui.theme.Fonts[this.Font].Draw(myText, myInterior, this.FontSize, this.FontColor);

            // we call this last because child components should be drawn on top of this.
            DrawComponents();
        }

        public override void DoMouseDown(MouseEventArgs e)
        {
            //base.DoMouseDown(e);
            myStyle = "Pressed";
        }

        public override void DoMouseUp(MouseEventArgs e)
        {
            //base.DoMouseUp(e);
            myStyle = "Default";
        }

        public override void DoMouseExit(MouseEventArgs e)
        {
            //base.DoMouseExit(e);
            myStyle = "Default";
        }

        public override void DoMouseClick(MouseEventArgs e)
        {
            OnClick();
        }

        protected void OnClick()
        {
            if (this.Click != null) Click(this);
        }

        public override void DoKeyDown(KeyEventArgs e)
        {
            switch (e.Key)
            {
                case Keys.Space:
                case Keys.Enter:
                    OnClick();
                    break;
                case Keys.Tab:
                    if (myGui.keyboard.Shift)
                    { DoTabPrev(); }
                    else
                    { DoTabNext(); }
                    break;
            }
            OnKeyDown(e);
        }
    }
}
